// calc3.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream.h>
#include <objbase.h>

#include "ifaccalc.h"
#include "guidcalc.cpp"

void trace(const char* msg){cout<<msg<<endl;}
void isHr(const HRESULT hr, char* great, char* bad)
{
if(SUCCEEDED(hr))
	cout<<great<<endl;
else
	cout<<":"<<bad<<", hr="<<hr;
}


int main(int argc, char* argv[])
{
trace("try CoInitialize()");
CoInitialize(NULL);

	
ICalcEngineStack* pStack;
ICalcEngineArif * pArif;


cout<<"try CoCreateInstance: ";
HRESULT hr = ::CoCreateInstance(CLSID_AVACALCENGINE,
				NULL,
				CLSCTX_INPROC_SERVER,
				IID_CALCSTACK,
				(void**)&pStack);
isHr(hr, "great!", "Can`t CoCreateInstance");


cout<<"try QueryInterface: ";
hr = pStack->QueryInterface(IID_CALCARIF, (void**)&pArif);
isHr(hr,"great!","Can`t CoCreateInstance");

//  
//----------------
// 

pStack->PushValue(2.0);
pStack->PushValue(4.0);
pStack->PushValue(2.0);
pStack->PushValue(3.0);
pStack->PushValue(4.0);
trace("try Arif: ");
double dRes;
cout << "ArifAdd=";
pArif->ArifAdd(dRes);
cout<<dRes<<endl;
cout << "ArifMul=";
pArif->ArifMul(dRes);
cout<<dRes<<endl;
cout << "ArifSub=";
pArif->ArifSub(dRes);
cout<<dRes<<endl;
cout << "ArifDiv=";
pArif->ArifDiv(dRes);
cout<<dRes<<endl;

cout<<"try create CAvaLcd";
ILcdAccess *pAccess;
ILcdMode *pMode;

hr = ::CoCreateInstance(CLSID_AVACALCLCD, 
				NULL,
				CLSCTX_INPROC_SERVER,
				IID_LCDACCESS,
				(void**)&pAccess);
isHr(hr, "great!", "Can`t CoCreateInstance");

cout <<"try QI ILcdMode";
hr = pAccess->QueryInterface(IID_LCDMODE, (void**)&pMode);
isHr(hr, "great!", "Can`t QI LcdMode");

double dTest, dTest2;
dTest=10.0;
dTest2=0;

pAccess->SetDouble(dTest);
pAccess->GetDouble(dTest2);
cout <<"in Dec "<<dTest2<<endl;

trace("switch to HEX mode");
pMode->SetHexMode();

char sz[30];
sz[29]=0;
pAccess->GetString(sz);
cout<<"in HEX "<<sz<<endl;

cout <<"try QI ILcdEdit";
ILcdEdit* pEdit;
hr = pAccess->QueryInterface(IID_LCDEDIT, (void**)&pEdit);
isHr(hr, "great!", "Can`t QI LcdEdit");
cout<<"Add Last 4"<<endl;
pEdit->AddLast(4);
pAccess->GetString(sz);
cout<<sz<<endl;
cout<<"now dellast!"<<endl;
pEdit->DelLast();
pAccess->GetString(sz);
cout<<sz<<endl;

trace ("SetString('1234.56') in DecMode");
//pMode->SetDecMode();
pMode->SetDecMode();

pAccess->SetString("1234.56");
//pAccess->SetDouble(dTest);
pAccess->GetDouble(dTest2);
cout <<"in Dec "<<dTest2<<endl;

pMode->SetHexMode();
trace("in Hex mode testing SetString 'Abc'");
pAccess->SetString("ABC");
pAccess->GetDouble(dTest2);
cout <<"in Dec "<<dTest2<<endl;


trace("Kernel tracing");
ICalcKernelProcess* pKernel;
ILcdAccess * pAccess1;

hr = ::CoCreateInstance(CLSID_AVACALCKERNEL, 
				NULL,
				CLSCTX_INPROC_SERVER,
				IID_CALCKERNELPROC,
				(void**)&pKernel);

isHr(hr, "great!", "Can`t Create Kernel");


hr = pKernel->QueryInterface(IID_LCDACCESS, (void**)&pAccess1);
// pKernel->NextCommand("Oct");
char sz1[30];
pAccess1->SetDouble(0.123);
pAccess1->GetString(sz1);
cout<<sz1<<endl;

//cout << "enter next cmd:";
//cin>>sz1;
//pKernel->NextCommand(sz1);
pKernel->NextCommand("\b");
pAccess1->GetString(sz1);
cout<<sz1<<endl;
pKernel->NextCommand("\b");
pAccess1->GetString(sz1);
cout<<sz1<<endl;

/*
pKernel->NextCommand("4");
pAccess1->GetString(sz1);
cout<<sz1<<endl;
pKernel->NextCommand("5");
pAccess1->GetString(sz1);
cout<<sz1<<endl;

pAccess1->GetString(sz1);
cout<<sz1<<endl;
double d1;
pAccess1->GetDouble(d1);
cout<<d1<<endl;
*/
CoUninitialize();
	return 0;
}

