//
// ifaccalc.h - 
//    Declarations of interfaces, IIDs, and CLSID
//      AvaCalc
//
#ifndef __ifaccalc__
#define __ifaccalc__


#include <winerror.h>

//   Lcd,    
enum AvaLcdMode {lcd_bin=2, lcd_oct=8, lcd_dec=10, lcd_hex=16};

//   Kernel,    .
enum AvaKernelMode {kernel_editing=0, kernel_operating=1};




//ICalcEngineStack -   
interface ICalcEngineStack : IUnknown
{
	//Reset -    
	virtual HRESULT __stdcall Reset()=0;
	//ClearValue -    
	virtual HRESULT __stdcall PopValue(double& dValue)=0;
	//PushValue -     
	virtual HRESULT __stdcall PushValue(const double dValue)=0;
	//GetValue -     
	virtual HRESULT __stdcall GetValue(double& dValue)=0;
	//ChangeValue -    
	virtual HRESULT __stdcall ChangeValue(const double dValue)=0;
	//CountStack -     
	virtual HRESULT __stdcall CountStack(long& clCount)=0;
};


// ICalcEngineArif -   
//     
interface ICalcEngineArif : IUnknown
{
	virtual HRESULT __stdcall ArifAdd(double& dValue)=0;
	virtual HRESULT __stdcall ArifSub(double& dValue)=0;
	virtual HRESULT __stdcall ArifMul(double& dValue)=0;
	virtual HRESULT __stdcall ArifDiv(double& dValue)=0;
};


//ILcdAccess -      
//  .
interface ILcdAccess : IUnknown
{
	virtual HRESULT __stdcall GetDouble(double& dValue)=0;
	virtual HRESULT __stdcall SetDouble(const double dValue)=0;

	//    
	//      
	//   : bin, oct, dec, hex
	virtual HRESULT __stdcall GetString(char* sz)=0;
	//  ,    - 
	virtual HRESULT __stdcall SetString(char* sz)=0;
};


//ILcdEdit - ,   
//  
//    
interface ILcdEdit : IUnknown
{
	virtual HRESULT __stdcall AddLast(double dDigit)=0;
	virtual HRESULT __stdcall DelLast()=0;
	virtual HRESULT __stdcall AddLast(char* szDigit)=0;
};


//ILcdMode -    
//   : bin, oct, dec, hex
interface ILcdMode : IUnknown
{
	// ,   
	virtual HRESULT __stdcall SetMode(const AvaLcdMode mode)=0;
	virtual HRESULT __stdcall GetMode(AvaLcdMode* mode)=0;
	
	//SetBinMode SetOctMode SetDecMode SetHexNode - 
	// SetMode
	virtual HRESULT __stdcall SetBinMode()=0;
	virtual HRESULT __stdcall SetOctMode()=0;
	virtual HRESULT __stdcall SetDecMode()=0;
	virtual HRESULT __stdcall SetHexMode()=0;

	//      
	virtual HRESULT __stdcall SetBinLen(const long lLen)=0;
	virtual HRESULT __stdcall GetBinLen(long& lLen)=0;
	virtual HRESULT __stdcall SetOctLen(const long lLen)=0;
	virtual HRESULT __stdcall GetOctLen(long& lLen)=0;
	virtual HRESULT __stdcall SetHexLen(const long lLen)=0;
	virtual HRESULT __stdcall GetHexLen(long& lLen)=0;
	virtual HRESULT __stdcall SetDecBeforePoint(const long lLen)=0;
	virtual HRESULT __stdcall GetDecBeforePoint(long& lLen)=0;
	virtual HRESULT __stdcall SetAfterPoint(const long lLen)=0;
	virtual HRESULT __stdcall GetAfterPoint(long& lLen)=0;
};


//ICalcKernelProcess -   
//    ( )
interface ICalcKernelProcess : IUnknown
{
	//NextCommand   
	//    (0-9, A-F), 
	//   
	virtual HRESULT __stdcall NextCommand(char* sz)=0;

};

//DEL interface IZ : IUnknown
//DEL {
//DEL 	virtual void pascal Fz() = 0 ;
//DEL };

//
//  IID  CLSID   
//  guidcalc.cpp
//
extern "C" const IID IID_CALCSTACK;
extern "C" const IID IID_CALCARIF;
extern "C" const IID IID_LCDACCESS;
extern "C" const IID IID_LCDMODE;
extern "C" const IID IID_LCDEDIT;
extern "C" const IID IID_CALCKERNELPROC;

extern "C" const CLSID CLSID_AVACALCENGINE;
extern "C" const CLSID CLSID_AVACALCLCD;
extern "C" const CLSID CLSID_AVACALCKERNEL;


//  
#define E_AVACALC_NO_DATA MAKE_HRESULT(SEVERITY_ERROR, FACILITY_ITF, 100);
#define E_AVACALC_STACK_OVERFLOW MAKE_HRESULT(SEVERITY_ERROR, FACILITY_ITF, 101);
#define E_AVACALC_DIV_ZERO MAKE_HRESULT(SEVERITY_ERROR, FACILITY_ITF, 102);
#define E_AVACALC_OVERFLOW MAKE_HRESULT(SEVERITY_ERROR, FACILITY_ITF, 103);

#endif